var IntegracaoController = function (templateManager, ZhPreferences, ZhFilterPreferences, MessageService) {

    let copyToClipboard = str => {
        const el = document.createElement('textarea');
        el.value = str;
        document.body.appendChild(el);
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
    };

    function buildFilter(name, value) {
        return {
            "name": name,
            "operator": "=",
            "value": value
        };
    }

    function setNRLOGINTCARDAMESOnDataSourceFilter (widget, value){
        if(widget.dataSourceFilter.find(dsf=> dsf.name === 'NRLOGINTCARDAMES')){
            widget.dataSourceFilter.find(dsf=> dsf.name === 'NRLOGINTCARDAMES').value = value;
        }else{
            widget.dataSourceFilter.push(buildFilter('NRLOGINTCARDAMES', value));
        }
    }

    this.onTabEnter = function (widget){
        widget.reload();
    };

    this.openFilterOnStart = function () {
        let widget = templateManager.container.getWidget('log');
        ZhPreferences.getDefaultWidgetPreferences(widget.id).then(result => {
            ZhFilterPreferences.openFilterWidget(widget, {});
        });
    };

    this.setFiltredDates = function (args) {
        
        let widget = templateManager.container.getWidget('log');

        let dates = args.e.preference.FILTER_ROW.DATAFILTER;
        let start = moment(dates.start, 'YYYY-MM-DD').format('DD/MM/YYYY');
        let end = moment(dates.end, 'YYYY-MM-DD').format('DD/MM/YYYY');

        if(start == "Invalid date"|| end == "Invalid date"){
            start = null;
            end = null;
        }

        widget.dataSourceFilter.push(buildFilter('DTINICIO', start));
        widget.dataSourceFilter.push(buildFilter('DTFIM', end));

        widget.dataSourceFilter = widget.dataSourceFilter.filter(dsf =>
            dsf.name !== "DATAFILTER"
        );
        
        widget.reload();
    };

    this.copyToClipBoardAction = function () {
        let widget = templateManager.container.getWidget('log');
        let json = widget.currentRow.DSARQIMPORT;
        copyToClipboard(json);
        MessageService.notificationMessageByCode("copiedToClipboard", null, {type: "success"});
    };

    this.setFilterForMod = function (){
        let widget = templateManager.container.getWidget('log');
        let NRLOGINTCARDAMES = widget.currentRow.NRLOGINTCARDAMES;
        let tabModWiget = widget.widgets.find(w=>w.name==='modified');
        let tabExCWiget = widget.widgets.find(w=>w.name==='excluded');
        let tabErrWiget = widget.widgets.find(w=>w.name==='errors');

        if(widget.currentRow.HASERRORS === 'S'){
            tabExCWiget.isVisible = false;
            tabErrWiget.isVisible = true;
        }else if (widget.currentRow.HASERRORS === 'N'){
            tabExCWiget.isVisible = true;
            tabErrWiget.isVisible = false;
        }

        setNRLOGINTCARDAMESOnDataSourceFilter(tabModWiget, NRLOGINTCARDAMES);
        setNRLOGINTCARDAMESOnDataSourceFilter(tabExCWiget,NRLOGINTCARDAMES);
        setNRLOGINTCARDAMESOnDataSourceFilter(tabErrWiget,NRLOGINTCARDAMES);
    };
    
};

Configuration(function (ContextRegister) {
    ContextRegister.register('IntegracaoController', IntegracaoController);
});